function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["menuData", "icon", "iconProps", "hoverClass"],
  _excluded2 = ["style"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useState } from 'react';
import { Dropdown, Icon } from 'rlj-design';
import "./style/index.less";
import { PREFIX_CLS } from "../constants/dictionary";
import cls from 'classnames';

/**
 * @description 下拉菜单,添加默认hover背景色
 * @param menuData // 下拉menu数据
 * @param icon 自定益icon
 * @param iconProps icon属性
 * @param reset Dropdown属性
 * @author xiLou
 * @date 2023/2/27
 * @returns
 * */
var prefix_cls = "".concat(PREFIX_CLS, "-hover-style");
var DropdownHover = function DropdownHover(_ref) {
  var menuData = _ref.menuData,
    icon = _ref.icon,
    iconProps = _ref.iconProps,
    hoverClass = _ref.hoverClass,
    otherDropdown = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    _ = _useState2[0],
    setOpen = _useState2[1];
  var _ref2 = iconProps || {},
    style = _ref2.style,
    otherIcon = _objectWithoutProperties(_ref2, _excluded2);
  // 过滤没有权限的数据
  var _filter = menuData.filter(function (i) {
    return (i === null || i === void 0 ? void 0 : i.auth) === true || (i === null || i === void 0 ? void 0 : i.auth) === undefined;
  });
  // 删除auth属性
  var _data = _filter.map(function (i) {
    delete i.auth;
    return i;
  });
  // 判断menuData长度，数据不存在隐藏
  if (!(_data !== null && _data !== void 0 && _data.length)) return null;
  return /*#__PURE__*/React.createElement(Dropdown, _extends({
    placement: "bottomRight",
    menu: {
      items: _data
    },
    onOpenChange: function onOpenChange(open) {
      return setOpen(open);
    },
    overlayStyle: {
      minWidth: 120
    },
    openClassName: "".concat(prefix_cls, "-wrapper-default-hover")
  }, otherDropdown), /*#__PURE__*/React.createElement("div", {
    className: cls("".concat(prefix_cls, "-wrapper"), hoverClass)
  }, icon ? ( /*#__PURE__*/React.cloneElement(icon, _objectSpread({}, iconProps))) : /*#__PURE__*/React.createElement(Icon, _extends({
    type: "moreTransverse",
    style: _objectSpread({
      fontSize: 16
    }, style)
  }, otherIcon))));
};
export default DropdownHover;