function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React from 'react';
import classnames from 'classnames';
import { Button } from 'rlj-design';
import { FieldSingleDrag } from "./components/FieldSingleDrag";
import { FieldMultipleDrag } from "./components/FieldMultipleDrag";
import { useStoreContext } from "./hooks";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/fieldDrag.less";
var prefixCls = "".concat(PREFIX_CLS, "-fieldDrag");
var FieldDrag = function FieldDrag(props) {
  var isDragGroup = props.isDragGroup,
    header = props.header,
    className = props.className,
    style = props.style;
  var _useStoreContext = useStoreContext(),
    fieldDragWidth = _useStoreContext.fieldDragWidth,
    isMultipleDragGroup = _useStoreContext.isMultipleDragGroup,
    setGroupSort = _useStoreContext.setGroupSort,
    groupSort = _useStoreContext.groupSort,
    groupDragable = _useStoreContext.groupDragable,
    dragable = _useStoreContext.dragable;
  var getHeaderRender = function getHeaderRender() {
    return header !== undefined ? header : /*#__PURE__*/React.createElement("p", null, "\u5DF2\u9009\u5B57\u6BB5", dragable && /*#__PURE__*/React.createElement("span", null, "\u53EF\u62D6\u62FD\u6807\u7B7E\u8C03\u6574\u987A\u5E8F"));
  };
  var getOperateBtnRender = function getOperateBtnRender() {
    return groupSort ? /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Button, {
      size: "small",
      onClick: function onClick() {
        return setGroupSort(false);
      }
    }, "\u53D6\u6D88"), /*#__PURE__*/React.createElement(Button, {
      type: "primary",
      size: "small",
      style: {
        marginLeft: 8
      },
      onClick: function onClick() {
        return setGroupSort(false);
      }
    }, "\u786E\u5B9A")) : groupDragable && /*#__PURE__*/React.createElement(Button, {
      type: "link",
      noPadding: true,
      onClick: function onClick() {
        return setGroupSort(true);
      }
    }, "\u5206\u7EC4\u6392\u5E8F");
  };
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(prefixCls, className),
    style: _objectSpread({
      width: fieldDragWidth
    }, style)
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-header")
  }, getHeaderRender(), isMultipleDragGroup && getOperateBtnRender()), isDragGroup ? /*#__PURE__*/React.createElement(FieldMultipleDrag, null) : /*#__PURE__*/React.createElement(FieldSingleDrag, null));
};
export default FieldDrag;