function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["columns", "defaultSelectFields", "onOk", "fieldDragWidth", "fieldDragProps", "fieldCheckboxProps", "className", "watchSelectFields", "isMultipleDragGroup", "dragable", "groupDragable"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useImperativeHandle, forwardRef, useState } from 'react';
import classnames from 'classnames';
import { PREFIX_CLS } from "../constants/dictionary";
import { StoreContext, useMultipleDataHandle } from "./hooks";
import { useUpdateEffect } from 'ahooks';
import FieldCheckbox from "./FieldCheckbox";
import FieldDrag from "./FieldDrag";
import FieldSingleSetting from "./FieldSingleSetting";
import MultipleFieldsModal from "./MultipleFieldsModal";
import SingleFieldsModal from "./SingleFieldsModal";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-fieldSetting");
var FieldSetting = /*#__PURE__*/forwardRef(function (props, ref) {
  var columns = props.columns,
    defaultSelectFields = props.defaultSelectFields,
    onOk = props.onOk,
    fieldDragWidth = props.fieldDragWidth,
    fieldDragProps = props.fieldDragProps,
    fieldCheckboxProps = props.fieldCheckboxProps,
    className = props.className,
    watchSelectFields = props.watchSelectFields,
    _props$isMultipleDrag = props.isMultipleDragGroup,
    isMultipleDragGroup = _props$isMultipleDrag === void 0 ? true : _props$isMultipleDrag,
    _props$dragable = props.dragable,
    dragable = _props$dragable === void 0 ? true : _props$dragable,
    _props$groupDragable = props.groupDragable,
    groupDragable = _props$groupDragable === void 0 ? true : _props$groupDragable,
    restProps = _objectWithoutProperties(props, _excluded);
  var data = useMultipleDataHandle(columns || [], isMultipleDragGroup);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    groupSort = _useState2[0],
    setGroupSort = _useState2[1];
  var selectFields = data.selectFields;
  var contextValue = _objectSpread({
    columns: columns,
    defaultSelectFields: defaultSelectFields,
    fieldDragWidth: fieldDragWidth,
    isMultipleDragGroup: isMultipleDragGroup,
    groupSort: groupSort,
    setGroupSort: setGroupSort,
    dragable: dragable,
    groupDragable: groupDragable
  }, data);
  useUpdateEffect(function () {
    watchSelectFields && watchSelectFields(selectFields);
  }, [selectFields]);
  useImperativeHandle(ref, function () {
    return {
      sortOk: sortOk,
      selectFields: selectFields
    };
  });
  var sortOk = function sortOk() {
    return onOk && onOk(selectFields);
  };
  return /*#__PURE__*/React.createElement(StoreContext.Provider, {
    value: contextValue
  }, /*#__PURE__*/React.createElement("div", _extends({
    className: classnames(prefixCls, className)
  }, restProps), /*#__PURE__*/React.createElement(FieldCheckbox, _extends({
    isCheckboxGroup: true
  }, fieldCheckboxProps)), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-line")
  }), /*#__PURE__*/React.createElement(FieldDrag, _extends({
    isDragGroup: true
  }, fieldDragProps))));
});
FieldSetting.FieldSingleSetting = FieldSingleSetting;
FieldSetting.MultipleFieldsModal = MultipleFieldsModal;
FieldSetting.SingleFieldsModal = SingleFieldsModal;
export default FieldSetting;