function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React from 'react';
import { Tag, Typography } from 'rlj-design';
import { useStoreContext } from "../hooks";
import { useDrag, useDrop } from 'react-dnd';
import classnames from 'classnames';
import { PREFIX_CLS } from "../../constants/dictionary";
import "../style/fieldDrag.less";
var LongText = Typography.LongText;
export var moveTagItem = function moveTagItem(temp, item, index) {
  // [temp[item.index], temp[index]] = [temp[index], temp[item.index]];
  var moveElement = temp[item.index];
  temp.splice(item.index, 1);
  temp.splice(index, 0, moveElement);
  return temp;
};
var TagItem = function TagItem(props) {
  var fieldId = props.fieldId,
    fieldDisabled = props.fieldDisabled,
    fieldName = props.fieldName,
    index = props.index,
    _props$type = props.type,
    type = _props$type === void 0 ? 'SINGLE_DND' : _props$type,
    closeTag = props.closeTag,
    dropHandle = props.dropHandle,
    groupId = props.groupId,
    status = props.status,
    _props$checkable = props.checkable,
    checkable = _props$checkable === void 0 ? true : _props$checkable;
  var _useStoreContext = useStoreContext(),
    dragable = _useStoreContext.dragable,
    checkedValueMap = _useStoreContext.checkedValueMap;
  var prefixCls = "".concat(PREFIX_CLS, "-fieldSingleDrag-TagItem");
  var _useDrop = useDrop(function () {
      return {
        accept: type,
        collect: function collect(monitor) {
          var _ref = monitor.getItem() || {},
            i = _ref.index;
          var left = "".concat(PREFIX_CLS, "-fieldSingleDrag-dropClassNameRight");
          var right = "".concat(PREFIX_CLS, "-fieldSingleDrag-dropClassNameLeft");
          var clsName = i <= index ? left : right;
          return {
            isOver: monitor.isOver(),
            dropClassName: i === index ? '' : clsName
          };
        },
        drop: function drop(item) {
          // 当移动项和目标项都不是禁用状态才可以进行移动排序
          if (!fieldDisabled && !item.fieldDisabled && item.index !== index) {
            dropHandle(item, index);
          }
        }
      };
    }, [index, checkedValueMap]),
    _useDrop2 = _slicedToArray(_useDrop, 2),
    _useDrop2$ = _useDrop2[0],
    dropClassName = _useDrop2$.dropClassName,
    isOver = _useDrop2$.isOver,
    drop = _useDrop2[1];

  // 监听字段拖动
  var _useDrag = useDrag(function () {
      return {
        type: type,
        item: {
          index: index,
          fieldDisabled: fieldDisabled,
          checkedValueMap: checkedValueMap
        },
        collect: function collect(monitor) {
          return {
            isDragging: monitor.isDragging()
          };
        }
      };
    }, [index, checkedValueMap]),
    _useDrag2 = _slicedToArray(_useDrag, 2),
    isDragging = _useDrag2[0].isDragging,
    drag = _useDrag2[1];
  var tagProps = fieldDisabled || !dragable ? {} : {
    ref: drag
  };
  return /*#__PURE__*/React.createElement("span", {
    key: fieldId,
    ref: drop,
    className: classnames(prefixCls, _defineProperty({}, dropClassName, isOver)),
    style: {
      display: status == 'delete' ? 'none' : 'inline'
    }
  }, /*#__PURE__*/React.createElement(Tag, _extends({}, tagProps, {
    type: "selected",
    closable: true,
    height: 24
  }, !checkable ? {
    closeIcon: /*#__PURE__*/React.createElement(React.Fragment, null)
  } : {}, {
    disabled: fieldDisabled,
    onClose: function onClose() {
      return closeTag(fieldId, groupId);
    },
    className: fieldDisabled ? undefined : classnames("".concat(prefixCls, "-tag"), _defineProperty({}, "".concat(prefixCls, "-drag"), isDragging))
  }), /*#__PURE__*/React.createElement(LongText, {
    text: fieldName || '',
    length: 24,
    tooltip: fieldName
  })));
};
export default TagItem;