function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useMemo, useState } from 'react';
export var useSigleDataHandle = function useSigleDataHandle(columns) {
  var _useState = useState(new Map(new Map([]))),
    _useState2 = _slicedToArray(_useState, 2),
    checkedValueMap = _useState2[0],
    setCheckedValueMap = _useState2[1];
  var _useMemo = useMemo(function () {
      var disableFields = [];
      var unDisableFields = [];
      columns === null || columns === void 0 || columns.forEach(function (_ref) {
        var fieldDisabled = _ref.fieldDisabled,
          fieldId = _ref.fieldId,
          checkable = _ref.checkable;
        if (fieldDisabled || checkable === false) {
          disableFields.push(fieldId);
        } else {
          unDisableFields.push(fieldId);
        }
      });
      return {
        disableFields: disableFields,
        unDisableFields: unDisableFields
      };
    }, [columns]),
    disableFields = _useMemo.disableFields,
    unDisableFields = _useMemo.unDisableFields;
  var _useMemo2 = useMemo(function () {
      var selectTemp = [];
      var selectFieldId = checkedValueMap.get('single') || [];
      columns === null || columns === void 0 || columns.forEach(function (item) {
        var fieldId = item.fieldId;
        var index = selectFieldId.indexOf(fieldId);
        if (index > -1) selectTemp[index] = item;
      });
      return {
        selectFields: selectTemp.filter(function (_ref2) {
          var status = _ref2.status;
          return status !== 'remove';
        }),
        selectAllFields: selectTemp,
        selectFieldId: selectFieldId
      };
    }, [checkedValueMap]),
    selectFields = _useMemo2.selectFields,
    selectFieldId = _useMemo2.selectFieldId,
    selectAllFields = _useMemo2.selectAllFields;
  return {
    fieldsData: columns,
    disableFields: disableFields,
    unDisableFields: unDisableFields,
    selectFields: selectFields,
    selectAllFields: selectAllFields,
    selectFieldId: selectFieldId,
    checkedValueMap: checkedValueMap,
    setCheckedValueMap: setCheckedValueMap
  };
};