function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useRef, useState, createContext, useEffect, useMemo } from 'react';
import classnames from 'classnames';
import { useUpdateEffect, useLocalStorageState } from 'ahooks';
import { Popover, Form } from 'rlj-design';
import moment from 'moment';
import FilterBtn from "./FilterBtn";
import FilterContent from "./FilterContent";
import FilterResult from "./FilterResult";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-filter");
export var FilterContext = /*#__PURE__*/createContext(null);
export var valueHandle = function valueHandle(fieldId, value, express) {
  var showValue = {
    fieldId: fieldId,
    selections: [],
    value: ''
  };
  if (typeof value === 'string') {
    showValue.value = value;
  }
  if (express) {
    showValue.value = value;
    showValue.express = express;
  }
  if (Array.isArray(value)) {
    var _ref = value || [],
      _ref2 = _slicedToArray(_ref, 2),
      firstItem = _ref2[0],
      secondItem = _ref2[1];
    if (firstItem !== null && firstItem !== void 0 && firstItem.value) {
      showValue.selections = value === null || value === void 0 ? void 0 : value.map(function (_ref3) {
        var value = _ref3.value;
        return value;
      });
    } else if (Array.isArray(firstItem)) {
      showValue.selections = value === null || value === void 0 ? void 0 : value.map(function (item) {
        return item[(item === null || item === void 0 ? void 0 : item.length) - 1];
      }).map(function (item) {
        return typeof item === 'string' ? item : item === null || item === void 0 ? void 0 : item.value;
      });
    } else {
      showValue.range = {
        from: moment(firstItem).format('YYYY-MM-DD'),
        to: moment(secondItem).format('YYYY-MM-DD')
      };
    }
  }
  if (value !== null && value !== void 0 && value.value) {
    showValue.selections = [value === null || value === void 0 ? void 0 : value.value];
  }
  return showValue;
};
var Filter = function Filter(props) {
  var overlayClassName = props.overlayClassName,
    trigger = props.trigger,
    btnText = props.btnText,
    btnRender = props.btnRender,
    filterTitle = props.filterTitle,
    filterSecondTitle = props.filterSecondTitle,
    filterNode = props.filterNode,
    filterLeftNode = props.filterLeftNode,
    showSelectedTag = props.showSelectedTag,
    realFilterOk = props.filterOk,
    addFields = props.addFields,
    items = props.items,
    searchFields = props.searchFields,
    cacheKey = props.cacheKey,
    destroyTooltipOnHide = props.destroyTooltipOnHide;
  var _Form$useForm = Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  var getFieldsValue = form.getFieldsValue;
  var filterRef = useRef(null);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var _useState3 = useState(new Map([])),
    _useState4 = _slicedToArray(_useState3, 2),
    itemsMap = _useState4[0],
    setItemsMap = _useState4[1];
  var _useLocalStorageState = useLocalStorageState(cacheKey || ''),
    _useLocalStorageState2 = _slicedToArray(_useLocalStorageState, 2),
    cacheFields = _useLocalStorageState2[0],
    setCachehFields = _useLocalStorageState2[1];
  var _useState5 = useState([]),
    _useState6 = _slicedToArray(_useState5, 2),
    fields = _useState6[0],
    setFields = _useState6[1];
  useEffect(function () {
    var tempItemMap = new Map(itemsMap);
    items === null || items === void 0 || items.forEach(function (_ref4) {
      var fieldId = _ref4.fieldId,
        fieldName = _ref4.fieldName,
        fieldType = _ref4.fieldType,
        multiSelect = _ref4.multiSelect,
        type = _ref4.type;
      tempItemMap.set(fieldId, {
        fieldId: fieldId,
        fieldName: fieldName,
        fieldType: fieldType,
        multiSelect: multiSelect,
        type: type
      });
    });
    setItemsMap(tempItemMap);
  }, [items]);
  var hasData = useMemo(function () {
    var _fields$filter;
    return !!(fields !== null && fields !== void 0 && (_fields$filter = fields.filter(function (item) {
      var _item$value;
      return String((_item$value = item === null || item === void 0 ? void 0 : item.value) !== null && _item$value !== void 0 ? _item$value : []);
    })) !== null && _fields$filter !== void 0 && _fields$filter.length);
  }, [fields]);
  useEffect(function () {
    if (!searchFields) return;
    setFields(searchFields);
  }, [searchFields]);
  useEffect(function () {
    cacheKey && !(searchFields !== null && searchFields !== void 0 && searchFields.length) && setFields(cacheFields);
  }, [cacheFields]);
  var resultHandle = function resultHandle() {
    var _getFieldsValue, _formFields$concat;
    var formFields = ((_getFieldsValue = getFieldsValue()) === null || _getFieldsValue === void 0 ? void 0 : _getFieldsValue.fields) || fields || [];
    return (formFields === null || formFields === void 0 || (_formFields$concat = formFields.concat(addFields)) === null || _formFields$concat === void 0 ? void 0 : _formFields$concat.filter(function (item) {
      var _item$value2;
      return String((_item$value2 = item === null || item === void 0 ? void 0 : item.value) !== null && _item$value2 !== void 0 ? _item$value2 : []);
    }).map(function (_ref5) {
      var fieldId = _ref5.fieldId,
        value = _ref5.value,
        express = _ref5.express;
      return valueHandle(fieldId, value, express);
    })) || [];
  };
  var filterOk = function filterOk() {
    cacheKey && !(searchFields !== null && searchFields !== void 0 && searchFields.length) && setCachehFields(fields);
    realFilterOk && realFilterOk(resultHandle(), fields);
  };
  useUpdateEffect(function () {
    filterOk && filterOk();
  }, [addFields, fields]);
  var contextValue = _objectSpread(_objectSpread({}, props), {}, {
    fields: fields,
    setFields: setFields,
    itemsMap: itemsMap,
    filterOk: filterOk,
    hasData: hasData
  });
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(FilterContext.Provider, {
    value: contextValue
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls,
    ref: filterRef
  }, filterLeftNode && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-filterLeftNode")
  }, filterLeftNode), /*#__PURE__*/React.createElement(Form, {
    form: form,
    name: "filter-content",
    autoComplete: "off"
  }, /*#__PURE__*/React.createElement(Popover, {
    content: /*#__PURE__*/React.createElement(FilterContent, {
      filterTitle: filterTitle,
      filterSecondTitle: filterSecondTitle
    }),
    placement: "bottomLeft",
    trigger: trigger,
    overlayClassName: classnames("".concat(prefixCls, "-popover"), overlayClassName),
    getPopupContainer: function getPopupContainer() {
      return filterRef.current;
    },
    open: open,
    onOpenChange: function onOpenChange(open) {
      return setOpen(open);
    },
    destroyTooltipOnHide: destroyTooltipOnHide
  }, btnRender ? btnRender : /*#__PURE__*/React.createElement(FilterBtn, {
    open: open,
    setOpen: setOpen
  }, btnText))), filterNode && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-filterNode")
  }, filterNode)), showSelectedTag && /*#__PURE__*/React.createElement(FilterResult, {
    form: form
  })));
};
Filter.defaultProps = {
  trigger: 'click',
  btnText: '筛选',
  unit: '项',
  total: 0,
  showSelectedTag: true,
  destroyTooltipOnHide: false
};
export default Filter;