function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useEffect, useState, useRef, useContext } from 'react';
import { Icon, Form } from 'rlj-design';
import FilterValue from "./FilterValue";
import { FilterContext } from "./Filter";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/filterContent.less";
var prefixCls = "".concat(PREFIX_CLS, "-filter-content");
var FilterContent = function FilterContent(props) {
  var filterTitle = props.filterTitle,
    filterSecondTitle = props.filterSecondTitle;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isTreeScroll = _useState2[0],
    setIsTreeScroll = _useState2[1];
  var ref = useRef(null);
  var _Form$useFormInstance = Form.useFormInstance(),
    validateFields = _Form$useFormInstance.validateFields,
    setFieldsValue = _Form$useFormInstance.setFieldsValue;
  var _ref = useContext(FilterContext),
    fields = _ref.fields;
  useEffect(function () {
    if (!(fields !== null && fields !== void 0 && fields.length)) {
      setFieldsValue({
        fields: [undefined]
      });
    } else {
      var tempFields = fields.map(function (item) {
        var value = item === null || item === void 0 ? void 0 : item.value;
        // 这里通过是否二维数组来判断是否为地址
        var isAddress = Array.isArray(value) && value.some(function (obj) {
          return Array.isArray(obj);
        });
        return _objectSpread(_objectSpread({}, item), {}, {
          value: isAddress ? value === null || value === void 0 ? void 0 : value.map(function (obj) {
            return obj.map(function (item) {
              return item.value;
            });
          }) : value
        });
      });
      setFieldsValue({
        fields: tempFields
      });
    }
  }, []);
  var addNewItem = function addNewItem(add) {
    validateFields().then(function () {
      add();
    }).then(function () {
      try {
        var _ref$current;
        ref.current.scrollTop = ref === null || ref === void 0 || (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.scrollHeight;
      } catch (error) {
        console.log(error);
      }
    }).catch(function (error) {
      console.log(error);
    });
  };
  var BORDER = {
    borderBottom: '1px solid #e6eaef',
    borderTop: '1px solid #e6eaef',
    paddingBottom: 12
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-title")
  }, filterTitle, /*#__PURE__*/React.createElement("span", null, filterSecondTitle)), /*#__PURE__*/React.createElement(Form.List, {
    name: "fields"
  }, function (fields, _ref2) {
    var add = _ref2.add,
      remove = _ref2.remove;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      ref: ref,
      className: "".concat(prefixCls, "-container"),
      style: isTreeScroll ? BORDER : {},
      onScroll: function onScroll(e) {
        return isTreeScroll === !e.target.scrollTop && setIsTreeScroll(!!e.target.scrollTop);
      }
    }, fields.map(function (item) {
      return /*#__PURE__*/React.createElement(FilterValue, {
        key: item.key,
        item: item,
        remove: remove
      });
    })), /*#__PURE__*/React.createElement(Form.Item, {
      style: {
        padding: '12px 0 16px 24px'
      }
    }, /*#__PURE__*/React.createElement("a", {
      className: "".concat(prefixCls, "-add"),
      onClick: function onClick() {
        return addNewItem(add);
      }
    }, /*#__PURE__*/React.createElement(Icon, {
      type: "add"
    }), "\u6DFB\u52A0\u7B5B\u9009\u6761\u4EF6")));
  }));
};
FilterContent.defaultProps = {
  filterTitle: '筛选',
  filterSecondTitle: '添加多个筛选条件，可交叉选择'
};
export default FilterContent;