// import React, {
//   cloneElement,
//   useEffect,
//   useMemo,
//   useRef,
//   useState,
// } from 'react';
// import { Feedback, ProgressPro } from 'rlj-pro';
// import { Button, message, Modal, Space } from 'rlj-design';
// import { useRequest } from 'ahooks';
// import { getRepeatStatusApi } from '@/services/repeat';
// import {
//   ERROR_IMG,
//   FINISH_MAP,
//   SUCCESS_IMG,
//   SUCCESS_IMG_GIF,
//   WARNING_IMG,
// } from './constants';
// import ss from './index.less';
// import CTable from '@/components/CTable';
// import InfoShow from './infoShow';
// import { history } from 'umi';

// import type { IApi, IPollProgress, IResult, ITask } from './type';
// import ExportData from '@/components/downloadFile';
// import { formatColumn, formatDataSource } from '@/hooks/useTableFormat/utils';
// import { IconDel } from '@/components';
// import { useAtomValue } from 'jotai';
// import { showDataHeadAtom } from '@/store/salaryCalculate';
// import { useQuery } from '@/hooks';

// let model: any;

// const closeModal = () => {
//   try {
//     model?.destroy();
//   } catch (e) {}
// };

// export const pollModal = {
//   taskOpen: (params: ITask) => {
//     // 将外部的 关闭回调 添加到内部的结果页
//     if (params?.closeCallback) {
//       params.result = { closeCallback: params.closeCallback };
//     }
//     closeModal();
//     // 打开 轮询 弹窗 使用 taskId的方式
//     model = Modal.info({
//       className: ss.box,
//       content: <PollProgress {...params} />,
//       icon: null,
//     });
//   },
//   apiOpen: (params: IApi) => {
//     // 将外部的 关闭回调 添加到内部的结果页
//     if (params?.closeCallback) {
//       params.result = { closeCallback: params.closeCallback };
//     }
//     closeModal();
//     // 打开 轮询 弹窗 使用 api的方式
//     model = Modal.info({
//       className: ss.box,
//       content: <PollProgress {...params} />,
//       icon: null,
//     });
//   },
//   open: (params: IResult) => {
//     closeModal();
//     // 直接打开 结果展示 弹窗
//     model = Modal.info({
//       className: ss.box,
//       content: <ResultStatus {...params} />,
//       icon: null,
//     });
//   },
// };

// /**
//  * 轮询组件
//  * 支持2中调用方式
//  *    1. taskId入参 组件外部请求好taskId后传入
//  *    2. api入参  组件内部请求获取taskId
//  *       2.1 api 返回 taskId 则使用taskId 轮询
//  *       2.2 api 返回 IResult类型的数据（判断是否有popupType） 则使用 ResultStatus 组件
//  * @param props
//  * @constructor
//  */
// export const PollProgress = (props: IPollProgress) => {
//   const {
//     taskId,
//     maxCount = 900,
//     services,
//     params,
//     completeAnimation,
//     getPollResult,
//     loadingTip = '加载中...',
//   } = props;

//   const { calBizId, payingActivityId } = useQuery();
//   const { pathname } = history.location;

//   const count = useRef<number>(0);

//   const [touchMaxPollCount, setTouchMaxPollCount] = useState<boolean>(false);
//   const [animationOk, setAnimationOk] = useState<boolean>(false);

//   const { data, run, cancel } = useRequest(getRepeatStatusApi, {
//     pollingInterval: 1000,
//     pollingErrorRetryCount: 0,
//     manual: true,
//     onSuccess: (res) => {
//       // 如果有getPollResult， 将轮询结果实时返回
//       getPollResult?.(res?.result);
//       count.current++;
//       if (FINISH_MAP.includes(res?.result?.popup?.popupType)) {
//         cancel();
//         setTouchMaxPollCount(false);
//       }
//       if (count.current >= maxCount) {
//         setTouchMaxPollCount(true);
//         cancel();
//         count.current = 0;
//       }
//     },
//     onError: (err) => {
//       cancel();
//     },
//   });

//   const result = useAtomValue(showDataHeadAtom);
//   const { schemaId } = result;

//   const dataApiRes = services
//     ? useRequest(services, {
//         manual: true,
//         onError: (err: any) => {
//           if (!err.success) {
//             if (err?.errorCode === 'err-6796') {
//               Feedback.ConfirmWarn({
//                 title: '计算失败',
//                 icon: <IconDel />,
//                 content: err?.errorMsg ?? '计算失败',
//                 cancelText: '我知道了',
//                 okText: '前往修改',
//                 onOk: () => {
//                   history.push({
//                     pathname: '/schemeDetail/schemeItem',
//                     query: {
//                       schemaId,
//                       calBizId,
//                       payingActivityId,
//                       source: `${pathname}`,
//                     },
//                   });
//                 },
//               });
//             } else {
//               message.error(err?.errorMsg ?? '计算失败');
//             }
//             try {
//               setTimeout(() => {
//                 model?.destroy();
//               }, 400);
//             } catch (e) {}
//           }
//         },
//       })
//     : { data: undefined, run: undefined, loading: false };
//   const { run: runApi, loading: loadingApi } = dataApiRes;
//   const dataApi: any = dataApiRes.data;

//   useEffect(() => {
//     return () => {
//       cancel();
//     };
//   }, []);

//   // taskId存在则直接开始轮询
//   useEffect(() => {
//     let curTaskId = taskId;
//     if (typeof dataApi?.result === 'string') {
//       curTaskId = dataApi?.result;
//     }
//     if (curTaskId) {
//       run({ taskId: curTaskId });
//     }
//   }, [taskId, dataApi]);

//   // api存在则先试用api的配置，获取返回值
//   useEffect(() => {
//     if (services && runApi) {
//       runApi(params ?? {});
//     }
//   }, [services, params]);

//   // 控制 进度条 结束总耗时（在拿到后端给的结束标识后，快速完成进度条动画）
//   const speed = useMemo(() => {
//     if (
//       FINISH_MAP.includes(data?.result?.popup?.popupType) ||
//       touchMaxPollCount
//     ) {
//       return 1;
//     } else {
//       return maxCount;
//     }
//   }, [data, touchMaxPollCount, maxCount]);

//   // RestStatus 组件的入参
//   const resultProps = useMemo(() => {
//     if (touchMaxPollCount) {
//       return { popupType: 'error', subPopTitle: '系统开小差，请重试~' };
//     } else {
//       return data?.result?.popup ?? {};
//     }
//   }, [data, touchMaxPollCount]);

//   // 进度条完结
//   const onComplete = () => {
//     if (completeAnimation) {
//       const tmp = completeAnimation(props);
//       // 返回false，则关闭弹窗
//       if (!tmp) {
//         try {
//           model?.destroy();
//         } catch (e) {}
//         // 返回值同时可以控制后续页面的展示 false 就不展示后端的结果页 了
//       } else {
//         setAnimationOk(true);
//       }
//     } else {
//       setAnimationOk(true);
//     }
//     // 动效结束的时候，如果轮询上限的标记还没有变化，改变轮询次数
//     if (!touchMaxPollCount) {
//       count.current = maxCount;
//     }
//   };

//   // if (services && loadingApi) return <div>任务id获取中...</div>;

//   if (services && dataApi?.result?.popup?.popupType) {
//     return <ResultStatus {...dataApi?.result?.popup} {...props?.result} />;
//   }

//   return (
//     <div className={ss.progressBox}>
//       <ProgressPro
//         loadingTip={loadingTip}
//         onComplete={onComplete}
//         speed={speed}
//         finishRender={
//           animationOk && <ResultStatus {...resultProps} {...props?.result} />
//         }
//       />
//     </div>
//   );
// };

// /**
//  * 结果展示组件
//  * @param props
//  * @constructor
//  */
// export const ResultStatus = (props: IResult) => {
//   const downloadRef = useRef<any>(null);

//   // 获取 Result 组件的顶部图标
//   const iconElement: any = useMemo(() => {
//     const normal = { className: ss.icon, height: 80, alt: '' };

//     if (!props.popupType) return null;

//     if (props.popupType === 'success' && props?.isDynamic !== false) {
//       return <img {...normal} src={SUCCESS_IMG_GIF} width={140} />;
//     } else if (props.popupType === 'success') {
//       return <img {...normal} src={SUCCESS_IMG} width={80} />;
//     } else if (props.popupType === 'error') {
//       return <img {...normal} src={ERROR_IMG} width={80} />;
//     } else if (props.popupType === 'warning') {
//       return <img {...normal} src={WARNING_IMG} width={80} />;
//     } else {
//       return null;
//     }
//   }, [props]);

//   const columns = formatColumn(props?.tableHeader ?? []);
//   const dataSource = formatDataSource(props?.tableBody ?? []);

//   const handleClose = () => {
//     try {
//       model?.destroy();
//     } catch (e) {}

//     props?.closeCallback?.(props);
//   };

//   const downloadError = (errorCacheKey?: string) => {
//     downloadRef.current.download({
//       action: '/hades/rest/api/v1/common/export/errorExport',
//       params: { errorCacheKey, filename: '错误信息' },
//     });
//   };

//   if (props.popupType === 'success' && props?.successElement) {
//     return cloneElement(props?.successElement, props);
//   }

//   return (
//     <div className={ss.resultBox}>
//       {iconElement}
//       {props?.popTitle && <div className={ss.title}>{props.popTitle}</div>}
//       <div className={ss.content}>
//         {/*副标题*/}
//         {props?.subPopTitle && (
//           <div className={ss.subTitle}>{props.subPopTitle}</div>
//         )}

//         {/*带底色的副标题*/}
//         {props?.popMsg && <div className={ss.gray1}>{props.popMsg}</div>}

//         {/*额外信息，比如a标签*/}
//         {props?.extraElement && (
//           <div className={ss.extra}>
//             {cloneElement(props.extraElement, props)}
//           </div>
//         )}

//         {/*表格*/}
//         {props?.tableHeader && props?.tableBody && (
//           <div className={ss.table}>
//             <CTable columns={columns} dataSource={dataSource} maxHeight={258} />
//           </div>
//         )}

//         {/*list数据*/}
//         {props?.listData && (
//           <div className={ss.infoShow}>
//             <InfoShow value={props.listData} />
//           </div>
//         )}

//         {/*footer按钮组*/}
//         {/*有表格，基本就是错误名单*/}
//         <div className={ss.btnBox}>
//           {props?.btnElement ? (
//             cloneElement(props.btnElement, {
//               ...props,
//               downloadError,
//               onClose: handleClose,
//             })
//           ) : props.cacheKey ? (
//             <Space>
//               <Button
//                 onClick={() => {
//                   handleClose();
//                 }}
//               >
//                 {props?.closeText ?? '我知道了'}
//               </Button>
//               <Button
//                 type="primary"
//                 onClick={() => downloadError(props.cacheKey)}
//               >
//                 下载错误名单
//               </Button>
//             </Space>
//           ) : (
//             <Button
//               type="primary"
//               onClick={() => {
//                 handleClose();
//               }}
//             >
//               {props?.closeText ?? '我知道了'}
//             </Button>
//           )}
//         </div>

//         {/*comment信息*/}
//         {props?.popComment && (
//           <div className={ss.gray2}>{props.popComment}</div>
//         )}
//       </div>
//       <ExportData ref={downloadRef} />
//     </div>
//   );
// };

// export { default as InfoShow } from './infoShow';