import {
  SALARY_BODY as SALARY_RESULT,
  SALARY_HEADER,
} from '@/hooks/useTableFormat/interface';
import { ReactElement } from 'react';

// 结果页面的入参
export interface IResult {
  popupType?: 'init' | 'doing' | 'success' | 'error' | 'warning' | null;
  popupCode?: string;
  popTitle?: string; // 主标题
  subPopTitle?: string; // 副标题
  popMsg?: string; // 带底色的副标题
  tableHeader?: SALARY_HEADER[]; // 动态表格header
  tableBody?: SALARY_RESULT[]; // 动态表格body
  listData?: { label: string; value: string }[]; // list数据
  popComment?: string; // 底部额外信息
  cacheKey?: string; // 错误名单下载 缓存key
  // 👆上面是后端给的，👇下面是前端配的
  isDynamic?: boolean; // 是否 带动效的 成功logo
  extraElement?: ReactElement; // 额外的内容，比如 跳转 a标签
  btnElement?: ReactElement; // 底部按钮组
  successElement?: ReactElement;
  closeText?: string; // 我知道了自定义文案
  closeCallback?: (params: IResult) => void; // 点击【我知道了】【完成】按钮的回调
}

export interface IPollProgress extends ITask, IApi {}

// taskOpen的入参
export interface ITask extends IProgress {
  taskId?: string;
}

// apiOpen的入参
export interface IApi extends IProgress {
  services?: any; // 自己在service定义好的接口方法
  params?: { [key in string]: any }; // 接口入参
}

// 进度条组件的入参
export interface IProgress {
  maxCount?: number; // 最大轮询次数，不传默认100次
  result?: IResult; // 结果展示 弹窗的 自定义
  closeCallback?: any; // IResult内部的一个值，放在这里，方便使用
  completeAnimation?: (params: IResult) => boolean; // 动画完成的回调，比如可以直接关闭弹窗，进行下一步操作 (返回 false 会 关闭弹窗)
  getPollResult?: (params: IResult) => void; // 试试获取轮询返回值
  loadingTip?: string;
}
