function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["type", "data", "children", "fieldProps", "hidden"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useMemo } from 'react';
import { Popover, Tooltip } from 'rlj-design';

/**
 * @description 一个地方当需要hover展示信息的时候，需要根据不同的条件展示不同的信息
 * @param data [{key: 1, text: '没有权限', satisfy: true, childrenProps:{}}]
 * @param type 'popover' | 'tooltip'
 * @param children
 * @param fieldProps 对应PopoverProps和TooltipProps属性值
 * @date: 2022/11/25
 * @return
 * */

var PromptHoc = function PromptHoc(_ref) {
  var _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'tooltip' : _ref$type,
    data = _ref.data,
    children = _ref.children,
    fieldProps = _ref.fieldProps,
    hidden = _ref.hidden,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _findIndex = useMemo(function () {
    return data.findIndex(function (i) {
      return i.satisfy;
    });
  }, [data]);

  // 如果hidden为true返回空
  if (hidden && _findIndex !== -1) {
    return null;
  }

  // 查找不到直接返回原dom元素
  if (_findIndex === -1) {
    // return children;
    return /*#__PURE__*/React.cloneElement(children, _objectSpread({}, rest));
  }
  var isDisabled = data[_findIndex].disabled;
  var DisabledCom = function DisabledCom() {
    var _data$_findIndex$chil, _data$_findIndex, _children$props, _data$_findIndex$chil2, _data$_findIndex2;
    return isDisabled ? /*#__PURE__*/React.createElement("span", {
      style: {
        cursor: 'not-allowed',
        display: 'inline-block'
      }
    }, /*#__PURE__*/React.cloneElement(children, _objectSpread(_objectSpread(_objectSpread({}, rest), (_data$_findIndex$chil = (_data$_findIndex = data[_findIndex]) === null || _data$_findIndex === void 0 ? void 0 : _data$_findIndex.childrenProps) !== null && _data$_findIndex$chil !== void 0 ? _data$_findIndex$chil : {}), {}, {
      disabled: isDisabled,
      style: Object.assign({}, (_children$props = children.props) === null || _children$props === void 0 ? void 0 : _children$props.style, {
        pointerEvents: 'none'
      })
    }))) : ( /*#__PURE__*/React.cloneElement(children, _objectSpread(_objectSpread({}, rest), (_data$_findIndex$chil2 = (_data$_findIndex2 = data[_findIndex]) === null || _data$_findIndex2 === void 0 ? void 0 : _data$_findIndex2.childrenProps) !== null && _data$_findIndex$chil2 !== void 0 ? _data$_findIndex$chil2 : {})));
  };

  // tooltip类型显示
  if (type === 'tooltip') {
    return /*#__PURE__*/React.createElement(Tooltip, _extends({
      title: data[_findIndex].text
    }, fieldProps), DisabledCom());
  }

  // popover类型显示
  if (type === 'popover') {
    return /*#__PURE__*/React.createElement(Popover, _extends({
      title: data[_findIndex].text
    }, fieldProps), DisabledCom());
  }
  return /*#__PURE__*/React.cloneElement(children, _objectSpread({}, rest));
};
export default PromptHoc;