function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useRef, useState, createContext, useEffect, useMemo } from 'react';
import { useLocalStorageState } from 'ahooks';
import classnames from 'classnames';
import { Popover, Form } from 'rlj-design';
import SortBtn from "./SortBtn";
import SortContent from "./SortContent";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-sort");
export var SortContext = /*#__PURE__*/createContext(null);
var Sort = function Sort(props) {
  var overlayClassName = props.overlayClassName,
    trigger = props.trigger,
    btnText = props.btnText,
    btnRender = props.btnRender,
    sortTitle = props.sortTitle,
    sortSecondTitle = props.sortSecondTitle,
    style = props.style,
    realSortOk = props.ok,
    items = props.items,
    _props$cacheKey = props.cacheKey,
    cacheKey = _props$cacheKey === void 0 ? 'sort' : _props$cacheKey,
    defaultFields = props.defaultFields,
    _props$showAutoSortBu = props.showAutoSortButton,
    showAutoSortButton = _props$showAutoSortBu === void 0 ? true : _props$showAutoSortBu,
    _props$isAutoSort = props.isAutoSort,
    isAutoSort = _props$isAutoSort === void 0 ? false : _props$isAutoSort;
  var _Form$useForm = Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  var validateFields = form.validateFields;
  var _useLocalStorageState = useLocalStorageState(cacheKey),
    _useLocalStorageState2 = _slicedToArray(_useLocalStorageState, 2),
    fields = _useLocalStorageState2[0],
    setFields = _useLocalStorageState2[1];
  var sortRef = useRef(null);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var _useState3 = useState(new Map([])),
    _useState4 = _slicedToArray(_useState3, 1),
    itemsMap = _useState4[0];
  var _useState5 = useState(new Map([])),
    _useState6 = _slicedToArray(_useState5, 1),
    addressMap = _useState6[0];
  var hasData = useMemo(function () {
    var _fields$filter;
    return !!(fields !== null && fields !== void 0 && (_fields$filter = fields.filter(function (item) {
      return item === null || item === void 0 ? void 0 : item.sortOrder;
    })) !== null && _fields$filter !== void 0 && _fields$filter.length);
  }, [fields]);
  useEffect(function () {
    if (!items || !(items !== null && items !== void 0 && items.length)) return;
    items === null || items === void 0 || items.forEach(function (_ref) {
      var fieldId = _ref.fieldId,
        sortStrategy = _ref.sortStrategy;
      (sortStrategy === null || sortStrategy === void 0 ? void 0 : sortStrategy.length) && itemsMap.set(fieldId, {
        fieldId: fieldId,
        sortStrategy: sortStrategy
      });
    });
    // 过滤一下fields，防止已停用字段不在表头中导致展示错误
    var newFields = fields === null || fields === void 0 ? void 0 : fields.filter(function (item) {
      return item && itemsMap.has(item === null || item === void 0 ? void 0 : item.fieldId);
    });
    setFields(newFields);
  }, [items]);
  useEffect(function () {
    if (!defaultFields) return;
    setFields(defaultFields);
  }, [defaultFields]);
  var onFinish = function onFinish() {
    var _fields$;
    if ((fields === null || fields === void 0 ? void 0 : fields.length) === 1 && !((_fields$ = fields[0]) !== null && _fields$ !== void 0 && _fields$.sortOrder)) {
      realSortOk && realSortOk([]);
    } else {
      validateFields().then(function () {
        ok();
      }).catch(function (err) {
        console.error(err);
      });
    }
  };
  var ok = function ok() {
    realSortOk && realSortOk(fields);
  };
  return /*#__PURE__*/React.createElement(SortContext.Provider, {
    value: _objectSpread(_objectSpread({}, props), {}, {
      fields: fields,
      setFields: setFields,
      itemsMap: itemsMap,
      ok: ok,
      addressMap: addressMap,
      hasData: hasData,
      setOpen: setOpen,
      onFinish: onFinish
    })
  }, /*#__PURE__*/React.createElement(Form, {
    form: form,
    name: "sort-content",
    autoComplete: "off"
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls,
    ref: sortRef
  }, /*#__PURE__*/React.createElement(Popover, {
    content: /*#__PURE__*/React.createElement(SortContent, {
      sortTitle: sortTitle,
      sortSecondTitle: sortSecondTitle,
      showAutoSortButton: showAutoSortButton,
      isAutoSort: isAutoSort
    }),
    placement: "bottomLeft",
    trigger: trigger,
    overlayClassName: classnames("".concat(prefixCls, "-popover"), overlayClassName),
    getPopupContainer: function getPopupContainer() {
      return sortRef.current;
    },
    open: open,
    onOpenChange: function onOpenChange(open) {
      return setOpen(open);
    }
  }, btnRender ? btnRender : /*#__PURE__*/React.createElement(SortBtn, {
    open: open,
    setOpen: setOpen,
    style: style
  }, btnText)))));
};
Sort.defaultProps = {
  cacheKey: 'sort',
  trigger: 'click',
  btnText: '排序',
  showAutoSortButton: true,
  isAutoSort: false
};
export default Sort;