export type IdType = string | number;
export type SortOrderType = 'ascend' | 'descend' | undefined;
export type Sorter = {
    column: {
        [key in IdType]: any;
    } | undefined;
    columnKey: string | number | undefined;
    field: string | number | undefined;
    order: SortOrderType;
};
export type FixedType = 'left' | 'right';
export type ValueTypeType = 'selection' | 'checkbox' | 'int' | 'number' | 'date' | 'address' | 'customize' | 'file' | 'org' | 'emp' | 'costCenter';
export type RenderModuleType = 'always' | 'memo';
export type HtmlRefType = HTMLDivElement | null;
export type PaginationType = {
    current: number;
    pageSize: number;
};
export type InfosType = {
    colId?: IdType;
    rowId?: IdType;
    msg?: string;
    className?: string;
    icon?: string;
    type?: 'error' | 'info' | 'warning';
};
