function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React, { useContext } from 'react';
import classnames from 'classnames';
import Ellipsis from "../../components/Ellipsis";
import "./item.less";
import { ExcelContext } from "../../index";
export default (function (props) {
  var _ref = useContext(ExcelContext),
    editableConfig = _ref.editableConfig,
    selectRow = _ref.selectRow,
    colData = _ref.colData,
    summation = _ref.summation;
  var summationData = summation === null || summation === void 0 ? void 0 : summation.data;
  var style = props.style,
    mainColumns = props.mainColumns;
  var subColumns = mainColumns.children;
  var isNotShowSub = !subColumns || !subColumns.length; //短路，当children不存在的时候，不会执行后半部分，不用判断children是否是数组

  var _ref2 = editableConfig || {},
    editable = _ref2.editable;

  // 默认的高度样式
  var defaultStyle = {
    height: colData.defaultItemHeight
  };

  /**
   * 超长省略内容
   * @param text   文本内容
   * @param item   当天列详细信息
   * @param textWidth  文字宽度
   * @param className  类名
   */
  var renderContent = function renderContent(text, item, textWidth, className) {
    if (text === 'rowSelectionChecked') {
      return '';
    }
    if (item.firstCol && summation !== null && summation !== void 0 && summation.remark) {
      return /*#__PURE__*/React.createElement("div", null, summation === null || summation === void 0 ? void 0 : summation.remark);
    }
    if ([undefined, null, ''].includes(text)) {
      return '';
    }
    return /*#__PURE__*/React.createElement("div", {
      className: className
    }, /*#__PURE__*/React.createElement(Ellipsis, {
      text: text,
      width: textWidth,
      isMaxWidth: false
    }));
  };
  var renderItem = function renderItem() {
    var item = function item(_item) {
      var _selectRow$currentCol;
      var width = _item.width,
        valueType = _item.valueType,
        dataIndex = _item.dataIndex;
      var ctxWidth = width - 20;
      var className = '';
      if (['int', 'number'].includes(valueType) && (true || !editable)) {
        className += ' int-value-style';
      }
      return /*#__PURE__*/React.createElement("div", {
        className: classnames('itemBox', {
          lastColHiddenBorder: _item.lastCol,
          salaryExcelHeaderHighlight: (selectRow === null || selectRow === void 0 || (_selectRow$currentCol = selectRow.currentColumn) === null || _selectRow$currentCol === void 0 ? void 0 : _selectRow$currentCol.dataIndex) === dataIndex
        }),
        style: _objectSpread({
          width: width
        }, defaultStyle),
        key: dataIndex
      }, renderContent(summationData === null || summationData === void 0 ? void 0 : summationData[dataIndex], _item, ctxWidth, className));
    };

    // 没有子表头
    if (isNotShowSub) {
      return item(mainColumns);
    } else {
      return /*#__PURE__*/React.createElement("div", {
        className: "childrenBox"
      }, subColumns.map(function (v) {
        return item(v);
      }));
    }
  };

  // =============================================== render ===============================================
  return /*#__PURE__*/React.createElement("div", {
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames('salaryExcelSummationItem')
  }, renderItem()));
});