function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { isValidElement, useRef, useState } from 'react';
import { Tooltip } from 'rlj-design';
import "./index.less";
var stopHoverFn = function stopHoverFn() {
  var extra = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  return window.tExcelResize || !extra;
};

// 拖动的时候要阻止hover，
export default function App(props) {
  var text = props.text,
    width = props.width,
    _props$hover = props.hover,
    hover = _props$hover === void 0 ? true : _props$hover,
    _props$isMaxWidth = props.isMaxWidth,
    isMaxWidth = _props$isMaxWidth === void 0 ? true : _props$isMaxWidth;
  var curSpanRef = useRef(null);
  var timerRef = useRef(null);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var onMouseEnter = function onMouseEnter() {
    if (stopHoverFn(hover)) return;
    var _ref = curSpanRef.current || {},
      offsetWidth = _ref.offsetWidth,
      scrollWidth = _ref.scrollWidth;
    if (!offsetWidth || !scrollWidth) return;
    if (offsetWidth < scrollWidth || width <= 22) {
      clearDelayTimer();
      toggleTooltip(true)();
    }
  };
  var onMouseLeave = function onMouseLeave() {
    if (stopHoverFn(hover)) return;
    timerRef.current = window.setTimeout(function () {
      toggleTooltip(false)();
      clearDelayTimer();
    }, 100);
  };
  var clearDelayTimer = function clearDelayTimer() {
    if (timerRef.current) {
      clearTimeout(timerRef.current);
      timerRef.current = null;
    }
  };
  var toggleTooltip = function toggleTooltip(open) {
    return function () {
      setOpen(open);
    };
  };
  if ( /*#__PURE__*/isValidElement(text) || text === null || text === undefined) return /*#__PURE__*/React.createElement(React.Fragment, null, text);
  return /*#__PURE__*/React.createElement(Tooltip, {
    open: open,
    overlayClassName: "table_ellipsis_span_tooltip",
    title: /*#__PURE__*/React.createElement("div", {
      className: "table_ellipsis_span_tooltip_inner",
      onMouseEnter: clearDelayTimer,
      onMouseLeave: toggleTooltip(false)
    }, text)
  }, /*#__PURE__*/React.createElement("div", {
    ref: curSpanRef,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave,
    className: "table_ellipsis_span",
    style: _objectSpread({
      lineHeight: 1.6
    }, isMaxWidth ? {
      maxWidth: width
    } : {
      width: width
    })
  }, width <= 22 ? '...' : text));
}